/**
 * @type {<T>(executor: (
 *   resolve: (value: T) => void,
 *   reject: (reason?: any) => void
 * ) => void) => Promise<T>}
 */
export const makePromise: <T>(executor: (resolve: (value: T) => void, reject: (reason?: any) => void) => void) => Promise<T>;
/** @typedef {<K, V>(entries?: readonly (readonly [K, V])[]) => Map<K, V>} MapFromEntries */
/** @typedef {<K, V>(iterable: Iterable<readonly [K, V]>) => Map<K, V>} MapFromIterable */
/** @type {MapFromEntries & MapFromIterable} */
export const makeMap: MapFromEntries & MapFromIterable;
/** @typedef {<T>(values?: readonly T[]) => Set<T>} SetFromValues */
/** @typedef {<T>(iterable: Iterable<T>) => Set<T>} SetFromIterable */
/** @type {SetFromValues & SetFromIterable} */
export const makeSet: SetFromValues & SetFromIterable;
/**
 * @typedef {<K extends {}, V = any>(
 *    entries?: readonly [K, V][] | null
 * ) => WeakMap<K, V>} WeakMapFromEntries
 */
/** @typedef {<K extends {}, V>(iterable: Iterable<[K, V]>) => WeakMap<K, V>} WeakMapFromIterable */
/** @type {WeakMapFromEntries & WeakMapFromIterable} */
export const makeWeakMap: WeakMapFromEntries & WeakMapFromIterable;
/** @typedef {<T extends {}>(values?: readonly T[]) => WeakSet<T>} WeakSetFromValues */
/** @typedef {<T extends {}>(iterable: Iterable<T>) => WeakSet<T>} WeakSetFromIterable */
/** @type {WeakSetFromValues & WeakSetFromIterable} */
export const makeWeakSet: WeakSetFromValues & WeakSetFromIterable;
export type MapFromEntries = <K, V>(entries?: readonly (readonly [K, V])[]) => Map<K, V>;
export type MapFromIterable = <K, V>(iterable: Iterable<readonly [K, V]>) => Map<K, V>;
export type SetFromValues = <T>(values?: readonly T[]) => Set<T>;
export type SetFromIterable = <T>(iterable: Iterable<T>) => Set<T>;
export type WeakMapFromEntries = <K extends {}, V = any>(entries?: readonly [K, V][]) => WeakMap<K, V>;
export type WeakMapFromIterable = <K extends {}, V>(iterable: Iterable<[K, V]>) => WeakMap<K, V>;
export type WeakSetFromValues = <T extends {}>(values?: readonly T[]) => WeakSet<T>;
export type WeakSetFromIterable = <T extends {}>(iterable: Iterable<T>) => WeakSet<T>;
//# sourceMappingURL=makers.d.ts.map